diff --git a/src/backend/utils/adt/arrayfuncs.c b/src/backend/utils/adt/arrayfuncs.c
index 54979fa..5591b46 100644
--- a/src/backend/utils/adt/arrayfuncs.c
+++ b/src/backend/utils/adt/arrayfuncs.c
@@ -1795,15 +1795,15 @@ array_cardinality(PG_FUNCTION_ARGS)
 
 
 /*
- * array_get_element :
- *	  This routine takes an array datum and a subscript array and returns
+ * array_ref :
+ *	  This routine takes an array pointer and a subscript array and returns
  *	  the referenced item as a Datum.  Note that for a pass-by-reference
  *	  datatype, the returned Datum is a pointer into the array object.
  *
  * This handles both ordinary varlena arrays and fixed-length arrays.
  *
  * Inputs:
- *	arraydatum: the array object (mustn't be NULL)
+ *	array: the array object (mustn't be NULL)
  *	nSubscripts: number of subscripts supplied
  *	indx[]: the subscript values
  *	arraytyplen: pg_type.typlen for the array type
@@ -1816,16 +1816,15 @@ array_cardinality(PG_FUNCTION_ARGS)
  *	*isNull is set to indicate whether the element is NULL.
  */
 Datum
-array_get_element(Datum arraydatum,
-				  int nSubscripts,
-				  int *indx,
-				  int arraytyplen,
-				  int elmlen,
-				  bool elmbyval,
-				  char elmalign,
-				  bool *isNull)
+array_ref(ArrayType *array,
+		  int nSubscripts,
+		  int *indx,
+		  int arraytyplen,
+		  int elmlen,
+		  bool elmbyval,
+		  char elmalign,
+		  bool *isNull)
 {
-	ArrayType  *array;
 	int			i,
 				ndim,
 			   *dim,
@@ -1847,13 +1846,13 @@ array_get_element(Datum arraydatum,
 		fixedLb[0] = 0;
 		dim = fixedDim;
 		lb = fixedLb;
-		arraydataptr = (char *) DatumGetPointer(arraydatum);
+		arraydataptr = (char *) array;
 		arraynullsptr = NULL;
 	}
 	else
 	{
 		/* detoast input array if necessary */
-		array = DatumGetArrayTypeP(arraydatum);
+		array = DatumGetArrayTypeP(PointerGetDatum(array));
 
 		ndim = ARR_NDIM(array);
 		dim = ARR_DIMS(array);
@@ -1911,7 +1910,7 @@ array_get_element(Datum arraydatum,
  * This handles both ordinary varlena arrays and fixed-length arrays.
  *
  * Inputs:
- *	arraydatum: the array object (mustn't be NULL)
+ *	array: the array object (mustn't be NULL)
  *	nSubscripts: number of subscripts supplied (must be same for upper/lower)
  *	upperIndx[]: the upper subscript values
  *	lowerIndx[]: the lower subscript values
@@ -1926,8 +1925,8 @@ array_get_element(Datum arraydatum,
  * NOTE: we assume it is OK to scribble on the provided subscript arrays
  * lowerIndx[] and upperIndx[].  These are generally just temporaries.
  */
-Datum
-array_get_slice(Datum arraydatum,
+ArrayType *
+array_get_slice(ArrayType *array,
 				int nSubscripts,
 				int *upperIndx,
 				int *lowerIndx,
@@ -1936,7 +1935,6 @@ array_get_slice(Datum arraydatum,
 				bool elmbyval,
 				char elmalign)
 {
-	ArrayType  *array;
 	ArrayType  *newarray;
 	int			i,
 				ndim,
@@ -1975,13 +1973,13 @@ array_get_slice(Datum arraydatum,
 		dim = fixedDim;
 		lb = fixedLb;
 		elemtype = InvalidOid;	/* XXX */
-		arraydataptr = (char *) DatumGetPointer(arraydatum);
+		arraydataptr = (char *) array;
 		arraynullsptr = NULL;
 	}
 	else
 	{
 		/* detoast input array if necessary */
-		array = DatumGetArrayTypeP(arraydatum);
+		array = DatumGetArrayTypeP(PointerGetDatum(array));
 
 		ndim = ARR_NDIM(array);
 		dim = ARR_DIMS(array);
@@ -1997,7 +1995,7 @@ array_get_slice(Datum arraydatum,
 	 * slice, return an empty array.
 	 */
 	if (ndim < nSubscripts || ndim <= 0 || ndim > MAXDIM)
-		return PointerGetDatum(construct_empty_array(elemtype));
+		return construct_empty_array(elemtype);
 
 	for (i = 0; i < nSubscripts; i++)
 	{
@@ -2006,7 +2004,7 @@ array_get_slice(Datum arraydatum,
 		if (upperIndx[i] >= (dim[i] + lb[i]))
 			upperIndx[i] = dim[i] + lb[i] - 1;
 		if (lowerIndx[i] > upperIndx[i])
-			return PointerGetDatum(construct_empty_array(elemtype));
+			return construct_empty_array(elemtype);
 	}
 	/* fill any missing subscript positions with full array range */
 	for (; i < ndim; i++)
@@ -2014,7 +2012,7 @@ array_get_slice(Datum arraydatum,
 		lowerIndx[i] = lb[i];
 		upperIndx[i] = dim[i] + lb[i] - 1;
 		if (lowerIndx[i] > upperIndx[i])
-			return PointerGetDatum(construct_empty_array(elemtype));
+			return construct_empty_array(elemtype);
 	}
 
 	mda_get_range(ndim, span, lowerIndx, upperIndx);
@@ -2060,18 +2058,18 @@ array_get_slice(Datum arraydatum,
 						lowerIndx, upperIndx,
 						elmlen, elmbyval, elmalign);
 
-	return PointerGetDatum(newarray);
+	return newarray;
 }
 
 /*
- * array_set_element :
- *		  This routine sets the value of one array element (specified by
+ * array_set :
+ *		  This routine sets the value of an array element (specified by
  *		  a subscript array) to a new value specified by "dataValue".
  *
  * This handles both ordinary varlena arrays and fixed-length arrays.
  *
  * Inputs:
- *	arraydatum: the initial array object (mustn't be NULL)
+ *	array: the initial array object (mustn't be NULL)
  *	nSubscripts: number of subscripts supplied
  *	indx[]: the subscript values
  *	dataValue: the datum to be inserted at the given position
@@ -2093,18 +2091,17 @@ array_get_slice(Datum arraydatum,
  * NOTE: For assignments, we throw an error for invalid subscripts etc,
  * rather than returning a NULL as the fetch operations do.
  */
-Datum
-array_set_element(Datum arraydatum,
-				  int nSubscripts,
-				  int *indx,
-				  Datum dataValue,
-				  bool isNull,
-				  int arraytyplen,
-				  int elmlen,
-				  bool elmbyval,
-				  char elmalign)
+ArrayType *
+array_set(ArrayType *array,
+		  int nSubscripts,
+		  int *indx,
+		  Datum dataValue,
+		  bool isNull,
+		  int arraytyplen,
+		  int elmlen,
+		  bool elmbyval,
+		  char elmalign)
 {
-	ArrayType  *array;
 	ArrayType  *newarray;
 	int			i,
 				ndim,
@@ -2133,8 +2130,6 @@ array_set_element(Datum arraydatum,
 		 * fixed-length arrays -- these are assumed to be 1-d, 0-based. We
 		 * cannot extend them, either.
 		 */
-		char	   *resultarray;
-
 		if (nSubscripts != 1)
 			ereport(ERROR,
 					(errcode(ERRCODE_ARRAY_SUBSCRIPT_ERROR),
@@ -2150,11 +2145,11 @@ array_set_element(Datum arraydatum,
 					(errcode(ERRCODE_NULL_VALUE_NOT_ALLOWED),
 					 errmsg("cannot assign null value to an element of a fixed-length array")));
 
-		resultarray = (char *) palloc(arraytyplen);
-		memcpy(resultarray, DatumGetPointer(arraydatum), arraytyplen);
-		elt_ptr = (char *) resultarray + indx[0] * elmlen;
+		newarray = (ArrayType *) palloc(arraytyplen);
+		memcpy(newarray, array, arraytyplen);
+		elt_ptr = (char *) newarray + indx[0] * elmlen;
 		ArrayCastAndSet(dataValue, elmlen, elmbyval, elmalign, elt_ptr);
-		return PointerGetDatum(resultarray);
+		return newarray;
 	}
 
 	if (nSubscripts <= 0 || nSubscripts > MAXDIM)
@@ -2167,7 +2162,7 @@ array_set_element(Datum arraydatum,
 		dataValue = PointerGetDatum(PG_DETOAST_DATUM(dataValue));
 
 	/* detoast input array if necessary */
-	array = DatumGetArrayTypeP(arraydatum);
+	array = DatumGetArrayTypeP(PointerGetDatum(array));
 
 	ndim = ARR_NDIM(array);
 
@@ -2186,10 +2181,9 @@ array_set_element(Datum arraydatum,
 			lb[i] = indx[i];
 		}
 
-		return PointerGetDatum(construct_md_array(&dataValue, &isNull,
-												  nSubscripts, dim, lb,
-												  elmtype,
-												elmlen, elmbyval, elmalign));
+		return construct_md_array(&dataValue, &isNull, nSubscripts,
+								  dim, lb, elmtype,
+								  elmlen, elmbyval, elmalign);
 	}
 
 	if (ndim != nSubscripts)
@@ -2351,7 +2345,7 @@ array_set_element(Datum arraydatum,
 		}
 	}
 
-	return PointerGetDatum(newarray);
+	return newarray;
 }
 
 /*
@@ -2363,12 +2357,12 @@ array_set_element(Datum arraydatum,
  * This handles both ordinary varlena arrays and fixed-length arrays.
  *
  * Inputs:
- *	arraydatum: the initial array object (mustn't be NULL)
+ *	array: the initial array object (mustn't be NULL)
  *	nSubscripts: number of subscripts supplied (must be same for upper/lower)
  *	upperIndx[]: the upper subscript values
  *	lowerIndx[]: the lower subscript values
- *	srcArrayDatum: the source for the inserted values
- *	isNull: indicates whether srcArrayDatum is NULL
+ *	srcArray: the source for the inserted values
+ *	isNull: indicates whether srcArray is NULL
  *	arraytyplen: pg_type.typlen for the array type
  *	elmlen: pg_type.typlen for the array's element type
  *	elmbyval: pg_type.typbyval for the array's element type
@@ -2389,20 +2383,18 @@ array_set_element(Datum arraydatum,
  * NOTE: For assignments, we throw an error for silly subscripts etc,
  * rather than returning a NULL or empty array as the fetch operations do.
  */
-Datum
-array_set_slice(Datum arraydatum,
+ArrayType *
+array_set_slice(ArrayType *array,
 				int nSubscripts,
 				int *upperIndx,
 				int *lowerIndx,
-				Datum srcArrayDatum,
+				ArrayType *srcArray,
 				bool isNull,
 				int arraytyplen,
 				int elmlen,
 				bool elmbyval,
 				char elmalign)
 {
-	ArrayType  *array;
-	ArrayType  *srcArray;
 	ArrayType  *newarray;
 	int			i,
 				ndim,
@@ -2428,7 +2420,7 @@ array_set_slice(Datum arraydatum,
 
 	/* Currently, assignment from a NULL source array is a no-op */
 	if (isNull)
-		return arraydatum;
+		return array;
 
 	if (arraytyplen > 0)
 	{
@@ -2441,8 +2433,8 @@ array_set_slice(Datum arraydatum,
 	}
 
 	/* detoast arrays if necessary */
-	array = DatumGetArrayTypeP(arraydatum);
-	srcArray = DatumGetArrayTypeP(srcArrayDatum);
+	array = DatumGetArrayTypeP(PointerGetDatum(array));
+	srcArray = DatumGetArrayTypeP(PointerGetDatum(srcArray));
 
 	/* note: we assume srcArray contains no toasted elements */
 
@@ -2475,9 +2467,9 @@ array_set_slice(Datum arraydatum,
 					(errcode(ERRCODE_ARRAY_SUBSCRIPT_ERROR),
 					 errmsg("source array too small")));
 
-		return PointerGetDatum(construct_md_array(dvalues, dnulls, nSubscripts,
-												  dim, lb, elmtype,
-												elmlen, elmbyval, elmalign));
+		return construct_md_array(dvalues, dnulls, nSubscripts,
+								  dim, lb, elmtype,
+								  elmlen, elmbyval, elmalign);
 	}
 
 	if (ndim < nSubscripts || ndim <= 0 || ndim > MAXDIM)
@@ -2679,43 +2671,7 @@ array_set_slice(Datum arraydatum,
 		}
 	}
 
-	return PointerGetDatum(newarray);
-}
-
-/*
- * array_ref : backwards compatibility wrapper for array_get_element
- *
- * This only works for detoasted/flattened varlena arrays, since the array
- * argument is declared as "ArrayType *".  However there's enough code like
- * that to justify preserving this API.
- */
-Datum
-array_ref(ArrayType *array, int nSubscripts, int *indx,
-		  int arraytyplen, int elmlen, bool elmbyval, char elmalign,
-		  bool *isNull)
-{
-	return array_get_element(PointerGetDatum(array), nSubscripts, indx,
-							 arraytyplen, elmlen, elmbyval, elmalign,
-							 isNull);
-}
-
-/*
- * array_set : backwards compatibility wrapper for array_set_element
- *
- * This only works for detoasted/flattened varlena arrays, since the array
- * argument and result are declared as "ArrayType *".  However there's enough
- * code like that to justify preserving this API.
- */
-ArrayType *
-array_set(ArrayType *array, int nSubscripts, int *indx,
-		  Datum dataValue, bool isNull,
-		  int arraytyplen, int elmlen, bool elmbyval, char elmalign)
-{
-	return DatumGetArrayTypeP(array_set_element(PointerGetDatum(array),
-												nSubscripts, indx,
-												dataValue, isNull,
-												arraytyplen,
-												elmlen, elmbyval, elmalign));
+	return newarray;
 }
 
 /*
@@ -4650,7 +4606,6 @@ array_insert_slice(ArrayType *destArray,
  *
  *	element_type is the array element type (must be a valid array element type)
  *	rcontext is where to keep working state
- *	subcontext is a flag determining whether to use a separate memory context
  *
  * Note: there are two common schemes for using accumArrayResult().
  * In the older scheme, you start with a NULL ArrayBuildState pointer, and
@@ -4660,39 +4615,24 @@ array_insert_slice(ArrayType *destArray,
  * once per element.  In this scheme you always end with a non-NULL pointer
  * that you can pass to makeArrayResult; you get an empty array if there
  * were no elements.  This is preferred if an empty array is what you want.
- *
- * It's possible to choose whether to create a separate memory context for the
- * array build state, or whether to allocate it directly within rcontext.
- *
- * When there are many concurrent small states (e.g. array_agg() using hash
- * aggregation of many small groups), using a separate memory context for each
- * one may result in severe memory bloat. In such cases, use the same memory
- * context to initialize all such array build states, and pass
- * subcontext=false.
- *
- * In cases when the array build states have different lifetimes, using a
- * single memory context is impractical. Instead, pass subcontext=true so that
- * the array build states can be freed individually.
  */
 ArrayBuildState *
-initArrayResult(Oid element_type, MemoryContext rcontext, bool subcontext)
+initArrayResult(Oid element_type, MemoryContext rcontext)
 {
 	ArrayBuildState *astate;
-	MemoryContext arr_context = rcontext;
+	MemoryContext arr_context;
 
 	/* Make a temporary context to hold all the junk */
-	if (subcontext)
-		arr_context = AllocSetContextCreate(rcontext,
-											"accumArrayResult",
-											ALLOCSET_DEFAULT_MINSIZE,
-											ALLOCSET_DEFAULT_INITSIZE,
-											ALLOCSET_DEFAULT_MAXSIZE);
+	arr_context = AllocSetContextCreate(rcontext,
+										"accumArrayResult",
+										ALLOCSET_DEFAULT_MINSIZE,
+										ALLOCSET_DEFAULT_INITSIZE,
+										ALLOCSET_DEFAULT_MAXSIZE);
 
 	astate = (ArrayBuildState *)
 		MemoryContextAlloc(arr_context, sizeof(ArrayBuildState));
 	astate->mcontext = arr_context;
-	astate->private_cxt = subcontext;
-	astate->alen = (subcontext ? 64 : 8);	/* arbitrary starting array size */
+	astate->alen = 64;			/* arbitrary starting array size */
 	astate->dvalues = (Datum *)
 		MemoryContextAlloc(arr_context, astate->alen * sizeof(Datum));
 	astate->dnulls = (bool *)
@@ -4726,7 +4666,7 @@ accumArrayResult(ArrayBuildState *astate,
 	if (astate == NULL)
 	{
 		/* First time through --- initialize */
-		astate = initArrayResult(element_type, rcontext, true);
+		astate = initArrayResult(element_type, rcontext);
 	}
 	else
 	{
@@ -4773,9 +4713,6 @@ accumArrayResult(ArrayBuildState *astate,
 /*
  * makeArrayResult - produce 1-D final result of accumArrayResult
  *
- * Note: only releases astate if it was initialized within a separate memory
- * context (i.e. using subcontext=true when calling initArrayResult).
- *
  *	astate is working state (must not be NULL)
  *	rcontext is where to construct result
  */
@@ -4792,8 +4729,7 @@ makeArrayResult(ArrayBuildState *astate,
 	dims[0] = astate->nelems;
 	lbs[0] = 1;
 
-	return makeMdArrayResult(astate, ndims, dims, lbs, rcontext,
-							 astate->private_cxt);
+	return makeMdArrayResult(astate, ndims, dims, lbs, rcontext, true);
 }
 
 /*
@@ -4802,11 +4738,6 @@ makeArrayResult(ArrayBuildState *astate,
  * beware: no check that specified dimensions match the number of values
  * accumulated.
  *
- * Note: if the astate was not initialized within a separate memory context
- * (that is, initArrayResult was called with subcontext=false), then using
- * release=true is illegal. Instead, release astate along with the rest of its
- * context when appropriate.
- *
  *	astate is working state (must not be NULL)
  *	rcontext is where to construct result
  *	release is true if okay to release working state
@@ -4839,10 +4770,7 @@ makeMdArrayResult(ArrayBuildState *astate,
 
 	/* Clean up all the junk */
 	if (release)
-	{
-		Assert(astate->private_cxt);
 		MemoryContextDelete(astate->mcontext);
-	}
 
 	return PointerGetDatum(result);
 }
@@ -4859,42 +4787,26 @@ makeMdArrayResult(ArrayBuildState *astate,
  * initArrayResultArr - initialize an empty ArrayBuildStateArr
  *
  *	array_type is the array type (must be a valid varlena array type)
- *	element_type is the type of the array's elements (lookup if InvalidOid)
+ *	element_type is the type of the array's elements
  *	rcontext is where to keep working state
- *	subcontext is a flag determining whether to use a separate memory context
  */
 ArrayBuildStateArr *
-initArrayResultArr(Oid array_type, Oid element_type, MemoryContext rcontext,
-				   bool subcontext)
+initArrayResultArr(Oid array_type, Oid element_type, MemoryContext rcontext)
 {
 	ArrayBuildStateArr *astate;
-	MemoryContext arr_context = rcontext;   /* by default use the parent ctx */
-
-	/* Lookup element type, unless element_type already provided */
-	if (! OidIsValid(element_type))
-	{
-		element_type = get_element_type(array_type);
-
-		if (!OidIsValid(element_type))
-			ereport(ERROR,
-					(errcode(ERRCODE_DATATYPE_MISMATCH),
-					 errmsg("data type %s is not an array type",
-							format_type_be(array_type))));
-	}
+	MemoryContext arr_context;
 
 	/* Make a temporary context to hold all the junk */
-	if (subcontext)
-		arr_context = AllocSetContextCreate(rcontext,
-											"accumArrayResultArr",
-											ALLOCSET_DEFAULT_MINSIZE,
-											ALLOCSET_DEFAULT_INITSIZE,
-											ALLOCSET_DEFAULT_MAXSIZE);
+	arr_context = AllocSetContextCreate(rcontext,
+										"accumArrayResultArr",
+										ALLOCSET_DEFAULT_MINSIZE,
+										ALLOCSET_DEFAULT_INITSIZE,
+										ALLOCSET_DEFAULT_MAXSIZE);
 
 	/* Note we initialize all fields to zero */
 	astate = (ArrayBuildStateArr *)
 		MemoryContextAllocZero(arr_context, sizeof(ArrayBuildStateArr));
 	astate->mcontext = arr_context;
-	astate->private_cxt = subcontext;
 
 	/* Save relevant datatype information */
 	astate->array_type = array_type;
@@ -4941,9 +4853,21 @@ accumArrayResultArr(ArrayBuildStateArr *astate,
 	arg = DatumGetArrayTypeP(dvalue);
 
 	if (astate == NULL)
-		astate = initArrayResultArr(array_type, InvalidOid, rcontext, true);
+	{
+		/* First time through --- initialize */
+		Oid			element_type = get_element_type(array_type);
+
+		if (!OidIsValid(element_type))
+			ereport(ERROR,
+					(errcode(ERRCODE_DATATYPE_MISMATCH),
+					 errmsg("data type %s is not an array type",
+							format_type_be(array_type))));
+		astate = initArrayResultArr(array_type, element_type, rcontext);
+	}
 	else
+	{
 		Assert(astate->array_type == array_type);
+	}
 
 	oldcontext = MemoryContextSwitchTo(astate->mcontext);
 
@@ -5122,10 +5046,7 @@ makeArrayResultArr(ArrayBuildStateArr *astate,
 
 	/* Clean up all the junk */
 	if (release)
-	{
-		Assert(astate->private_cxt);
 		MemoryContextDelete(astate->mcontext);
-	}
 
 	return PointerGetDatum(result);
 }
@@ -5141,10 +5062,9 @@ makeArrayResultArr(ArrayBuildStateArr *astate,
  *
  *	input_type is the input datatype (either element or array type)
  *	rcontext is where to keep working state
- *	subcontext is a flag determining whether to use a separate memory context
  */
 ArrayBuildStateAny *
-initArrayResultAny(Oid input_type, MemoryContext rcontext, bool subcontext)
+initArrayResultAny(Oid input_type, MemoryContext rcontext)
 {
 	ArrayBuildStateAny *astate;
 	Oid			element_type = get_element_type(input_type);
@@ -5154,7 +5074,7 @@ initArrayResultAny(Oid input_type, MemoryContext rcontext, bool subcontext)
 		/* Array case */
 		ArrayBuildStateArr *arraystate;
 
-		arraystate = initArrayResultArr(input_type, InvalidOid, rcontext, subcontext);
+		arraystate = initArrayResultArr(input_type, element_type, rcontext);
 		astate = (ArrayBuildStateAny *)
 			MemoryContextAlloc(arraystate->mcontext,
 							   sizeof(ArrayBuildStateAny));
@@ -5169,7 +5089,7 @@ initArrayResultAny(Oid input_type, MemoryContext rcontext, bool subcontext)
 		/* Let's just check that we have a type that can be put into arrays */
 		Assert(OidIsValid(get_array_type(input_type)));
 
-		scalarstate = initArrayResult(input_type, rcontext, subcontext);
+		scalarstate = initArrayResult(input_type, rcontext);
 		astate = (ArrayBuildStateAny *)
 			MemoryContextAlloc(scalarstate->mcontext,
 							   sizeof(ArrayBuildStateAny));
@@ -5195,7 +5115,7 @@ accumArrayResultAny(ArrayBuildStateAny *astate,
 					MemoryContext rcontext)
 {
 	if (astate == NULL)
-		astate = initArrayResultAny(input_type, rcontext, true);
+		astate = initArrayResultAny(input_type, rcontext);
 
 	if (astate->scalarstate)
 		(void) accumArrayResult(astate->scalarstate,
diff --git a/src/backend/utils/adt/domains.c b/src/backend/utils/adt/domains.c
index ac8c252..d84d4e8 100644
--- a/src/backend/utils/adt/domains.c
+++ b/src/backend/utils/adt/domains.c
@@ -12,9 +12,10 @@
  * The overhead required for constraint checking can be high, since examining
  * the catalogs to discover the constraints for a given domain is not cheap.
  * We have three mechanisms for minimizing this cost:
- *	1.  We rely on the typcache to keep up-to-date copies of the constraints.
- *	2.  In a nest of domains, we flatten the checking of all the levels
- *		into just one operation (the typcache does this for us).
+ *	1.  In a nest of domains, we flatten the checking of all the levels
+ *		into just one operation.
+ *	2.  We cache the list of constraint items in the FmgrInfo struct
+ *		passed by the caller.
  *	3.  If there are CHECK constraints, we cache a standalone ExprContext
  *		to evaluate them in.
  *
@@ -32,12 +33,12 @@
 
 #include "access/htup_details.h"
 #include "catalog/pg_type.h"
+#include "commands/typecmds.h"
 #include "executor/executor.h"
 #include "lib/stringinfo.h"
 #include "utils/builtins.h"
 #include "utils/lsyscache.h"
 #include "utils/syscache.h"
-#include "utils/typcache.h"
 
 
 /*
@@ -51,8 +52,8 @@ typedef struct DomainIOData
 	Oid			typioparam;
 	int32		typtypmod;
 	FmgrInfo	proc;
-	/* Reference to cached list of constraint items to check */
-	DomainConstraintRef constraint_ref;
+	/* List of constraint items to check */
+	List	   *constraint_list;
 	/* Context for evaluating CHECK constraints in */
 	ExprContext *econtext;
 	/* Memory context this cache is in */
@@ -62,19 +63,16 @@ typedef struct DomainIOData
 
 /*
  * domain_state_setup - initialize the cache for a new domain type.
- *
- * Note: we can't re-use the same cache struct for a new domain type,
- * since there's no provision for releasing the DomainConstraintRef.
- * If a call site needs to deal with a new domain type, we just leak
- * the old struct for the duration of the query.
  */
-static DomainIOData *
-domain_state_setup(Oid domainType, bool binary, MemoryContext mcxt)
+static void
+domain_state_setup(DomainIOData *my_extra, Oid domainType, bool binary,
+				   MemoryContext mcxt)
 {
-	DomainIOData *my_extra;
 	Oid			baseType;
+	MemoryContext oldcontext;
 
-	my_extra = (DomainIOData *) MemoryContextAlloc(mcxt, sizeof(DomainIOData));
+	/* Mark cache invalid */
+	my_extra->domain_type = InvalidOid;
 
 	/* Find out the base type */
 	my_extra->typtypmod = -1;
@@ -97,7 +95,9 @@ domain_state_setup(Oid domainType, bool binary, MemoryContext mcxt)
 	fmgr_info_cxt(my_extra->typiofunc, &my_extra->proc, mcxt);
 
 	/* Look up constraints for domain */
-	InitDomainConstraintRef(domainType, &my_extra->constraint_ref, mcxt);
+	oldcontext = MemoryContextSwitchTo(mcxt);
+	my_extra->constraint_list = GetDomainConstraints(domainType);
+	MemoryContextSwitchTo(oldcontext);
 
 	/* We don't make an ExprContext until needed */
 	my_extra->econtext = NULL;
@@ -105,8 +105,6 @@ domain_state_setup(Oid domainType, bool binary, MemoryContext mcxt)
 
 	/* Mark cache valid */
 	my_extra->domain_type = domainType;
-
-	return my_extra;
 }
 
 /*
@@ -120,10 +118,7 @@ domain_check_input(Datum value, bool isnull, DomainIOData *my_extra)
 	ExprContext *econtext = my_extra->econtext;
 	ListCell   *l;
 
-	/* Make sure we have up-to-date constraints */
-	UpdateDomainConstraintRef(&my_extra->constraint_ref);
-
-	foreach(l, my_extra->constraint_ref.constraints)
+	foreach(l, my_extra->constraint_list)
 	{
 		DomainConstraintState *con = (DomainConstraintState *) lfirst(l);
 
@@ -220,16 +215,20 @@ domain_in(PG_FUNCTION_ARGS)
 
 	/*
 	 * We arrange to look up the needed info just once per series of calls,
-	 * assuming the domain type doesn't change underneath us (which really
-	 * shouldn't happen, but cope if it does).
+	 * assuming the domain type doesn't change underneath us.
 	 */
 	my_extra = (DomainIOData *) fcinfo->flinfo->fn_extra;
-	if (my_extra == NULL || my_extra->domain_type != domainType)
+	if (my_extra == NULL)
 	{
-		my_extra = domain_state_setup(domainType, false,
-									  fcinfo->flinfo->fn_mcxt);
+		my_extra = (DomainIOData *) MemoryContextAlloc(fcinfo->flinfo->fn_mcxt,
+													   sizeof(DomainIOData));
+		domain_state_setup(my_extra, domainType, false,
+						   fcinfo->flinfo->fn_mcxt);
 		fcinfo->flinfo->fn_extra = (void *) my_extra;
 	}
+	else if (my_extra->domain_type != domainType)
+		domain_state_setup(my_extra, domainType, false,
+						   fcinfo->flinfo->fn_mcxt);
 
 	/*
 	 * Invoke the base type's typinput procedure to convert the data.
@@ -276,16 +275,20 @@ domain_recv(PG_FUNCTION_ARGS)
 
 	/*
 	 * We arrange to look up the needed info just once per series of calls,
-	 * assuming the domain type doesn't change underneath us (which really
-	 * shouldn't happen, but cope if it does).
+	 * assuming the domain type doesn't change underneath us.
 	 */
 	my_extra = (DomainIOData *) fcinfo->flinfo->fn_extra;
-	if (my_extra == NULL || my_extra->domain_type != domainType)
+	if (my_extra == NULL)
 	{
-		my_extra = domain_state_setup(domainType, true,
-									  fcinfo->flinfo->fn_mcxt);
+		my_extra = (DomainIOData *) MemoryContextAlloc(fcinfo->flinfo->fn_mcxt,
+													   sizeof(DomainIOData));
+		domain_state_setup(my_extra, domainType, true,
+						   fcinfo->flinfo->fn_mcxt);
 		fcinfo->flinfo->fn_extra = (void *) my_extra;
 	}
+	else if (my_extra->domain_type != domainType)
+		domain_state_setup(my_extra, domainType, true,
+						   fcinfo->flinfo->fn_mcxt);
 
 	/*
 	 * Invoke the base type's typreceive procedure to convert the data.
@@ -323,17 +326,20 @@ domain_check(Datum value, bool isnull, Oid domainType,
 
 	/*
 	 * We arrange to look up the needed info just once per series of calls,
-	 * assuming the domain type doesn't change underneath us (which really
-	 * shouldn't happen, but cope if it does).
+	 * assuming the domain type doesn't change underneath us.
 	 */
 	if (extra)
 		my_extra = (DomainIOData *) *extra;
-	if (my_extra == NULL || my_extra->domain_type != domainType)
+	if (my_extra == NULL)
 	{
-		my_extra = domain_state_setup(domainType, true, mcxt);
+		my_extra = (DomainIOData *) MemoryContextAlloc(mcxt,
+													   sizeof(DomainIOData));
+		domain_state_setup(my_extra, domainType, true, mcxt);
 		if (extra)
 			*extra = (void *) my_extra;
 	}
+	else if (my_extra->domain_type != domainType)
+		domain_state_setup(my_extra, domainType, true, mcxt);
 
 	/*
 	 * Do the necessary checks to ensure it's a valid domain value.
diff --git a/src/backend/utils/adt/geo_ops.c b/src/backend/utils/adt/geo_ops.c
index 6cb6be5..6b6510e 100644
--- a/src/backend/utils/adt/geo_ops.c
+++ b/src/backend/utils/adt/geo_ops.c
@@ -1390,7 +1390,7 @@ path_in(PG_FUNCTION_ARGS)
 	}
 
 	base_size = sizeof(path->p[0]) * npts;
-	size = offsetof(PATH, p) +base_size;
+	size = offsetof(PATH, p[0]) +base_size;
 
 	/* Check for integer overflow */
 	if (base_size / npts != sizeof(path->p[0]) || size <= base_size)
@@ -1443,12 +1443,12 @@ path_recv(PG_FUNCTION_ARGS)
 
 	closed = pq_getmsgbyte(buf);
 	npts = pq_getmsgint(buf, sizeof(int32));
-	if (npts <= 0 || npts >= (int32) ((INT_MAX - offsetof(PATH, p)) / sizeof(Point)))
+	if (npts <= 0 || npts >= (int32) ((INT_MAX - offsetof(PATH, p[0])) / sizeof(Point)))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 			 errmsg("invalid number of points in external \"path\" value")));
 
-	size = offsetof(PATH, p) +sizeof(path->p[0]) * npts;
+	size = offsetof(PATH, p[0]) +sizeof(path->p[0]) * npts;
 	path = (PATH *) palloc(size);
 
 	SET_VARSIZE(path, size);
@@ -3476,7 +3476,7 @@ poly_in(PG_FUNCTION_ARGS)
 			  errmsg("invalid input syntax for type polygon: \"%s\"", str)));
 
 	base_size = sizeof(poly->p[0]) * npts;
-	size = offsetof(POLYGON, p) +base_size;
+	size = offsetof(POLYGON, p[0]) +base_size;
 
 	/* Check for integer overflow */
 	if (base_size / npts != sizeof(poly->p[0]) || size <= base_size)
@@ -3530,12 +3530,12 @@ poly_recv(PG_FUNCTION_ARGS)
 	int			size;
 
 	npts = pq_getmsgint(buf, sizeof(int32));
-	if (npts <= 0 || npts >= (int32) ((INT_MAX - offsetof(POLYGON, p)) / sizeof(Point)))
+	if (npts <= 0 || npts >= (int32) ((INT_MAX - offsetof(POLYGON, p[0])) / sizeof(Point)))
 		ereport(ERROR,
 				(errcode(ERRCODE_INVALID_BINARY_REPRESENTATION),
 		  errmsg("invalid number of points in external \"polygon\" value")));
 
-	size = offsetof(POLYGON, p) +sizeof(poly->p[0]) * npts;
+	size = offsetof(POLYGON, p[0]) +sizeof(poly->p[0]) * npts;
 	poly = (POLYGON *) palloc0(size);	/* zero any holes */
 
 	SET_VARSIZE(poly, size);
@@ -4251,7 +4251,7 @@ path_add(PG_FUNCTION_ARGS)
 		PG_RETURN_NULL();
 
 	base_size = sizeof(p1->p[0]) * (p1->npts + p2->npts);
-	size = offsetof(PATH, p) +base_size;
+	size = offsetof(PATH, p[0]) +base_size;
 
 	/* Check for integer overflow */
 	if (base_size / sizeof(p1->p[0]) != (p1->npts + p2->npts) ||
@@ -4393,7 +4393,7 @@ path_poly(PG_FUNCTION_ARGS)
 	 * Never overflows: the old size fit in MaxAllocSize, and the new size is
 	 * just a small constant larger.
 	 */
-	size = offsetof(POLYGON, p) +sizeof(poly->p[0]) * path->npts;
+	size = offsetof(POLYGON, p[0]) +sizeof(poly->p[0]) * path->npts;
 	poly = (POLYGON *) palloc(size);
 
 	SET_VARSIZE(poly, size);
@@ -4468,7 +4468,7 @@ box_poly(PG_FUNCTION_ARGS)
 	int			size;
 
 	/* map four corners of the box to a polygon */
-	size = offsetof(POLYGON, p) +sizeof(poly->p[0]) * 4;
+	size = offsetof(POLYGON, p[0]) +sizeof(poly->p[0]) * 4;
 	poly = (POLYGON *) palloc(size);
 
 	SET_VARSIZE(poly, size);
@@ -4502,7 +4502,7 @@ poly_path(PG_FUNCTION_ARGS)
 	 * Never overflows: the old size fit in MaxAllocSize, and the new size is
 	 * smaller by a small constant.
 	 */
-	size = offsetof(PATH, p) +sizeof(path->p[0]) * poly->npts;
+	size = offsetof(PATH, p[0]) +sizeof(path->p[0]) * poly->npts;
 	path = (PATH *) palloc(size);
 
 	SET_VARSIZE(path, size);
@@ -5181,7 +5181,7 @@ circle_poly(PG_FUNCTION_ARGS)
 				 errmsg("must request at least 2 points")));
 
 	base_size = sizeof(poly->p[0]) * npts;
-	size = offsetof(POLYGON, p) +base_size;
+	size = offsetof(POLYGON, p[0]) +base_size;
 
 	/* Check for integer overflow */
 	if (base_size / npts != sizeof(poly->p[0]) || size <= base_size)
